<template>
    <div id="work-form">
        <hr class="my-3">
        <form @submit.prevent="handleSubmit">
            <h4 class="font-weight-normal">Work</h4>
            <!--person_id-->
            <div class="form-group">
                <label>Person</label>
                <selected v-if="person" @reselect:option="losePerson(true)" table="people" :selected="person"/>
                <quick-select v-else @select:option="savePerson" table="people"/>
                <small v-if="!person" class="text-muted">Required</small>
            </div>
            <!--title_id-->
            <div class="form-group">
                <label>Title</label>
                <selected v-if="title" @reselect:option="loseTitle(true)" table="entertainment" :selected="title"/>
                <quick-select v-else @select:option="saveTitle" table="entertainment"/>
                <small v-if="!title" class="text-muted">Required</small>
            </div>
            <!--job_id-->
            <div class="form-group">
                <label>Job</label>
                <selected v-if="job" @reselect:option="loseJob(true)" table="jobs" :selected="job"/>
                <custom-select v-else @select:option="saveJob" table="jobs"/>
                <small v-if="!job" class="text-muted">Required</small>
            </div>
            <div v-if="job && isActing" class="form-group">
                <label for="character_name">Character's name</label>
                <input type="text" class="form-control" id="character_name" autocomplete="off"
                       v-model="character_name">
                <small class="text-muted">Optional</small>
            </div>
            <button class="btn btn-primary">
                <span class="fas fa-plus"/> Insert
            </button>
            <p v-if="errors.success" class="bg-success text-white mt-4 px-2">Work inserted</p>
            <p v-else-if="errors.fail" class="bg-danger text-white mt-4 px-2">Something went wrong</p>
            <p v-else-if="errors.invalid" class="bg-danger text-white mt-4 px-2">Required input missing</p>
        </form>
    </div>
</template>

<script>
    import CustomSelect from "@/components/CustomSelect";
    import QuickSelect from "@/components/QuickSelect";
    import Selected from "@/components/Selected";

    export default {
        name: "work-form",
        components: {
            CustomSelect,
            Selected,
            QuickSelect
        },
        data() {
            return {
                person: null,
                title: null,
                job: null,
                work: {
                    person_id: null,
                    title_id: null,
                    job_id: null,
                },
                character_name: '',
                errors: {
                    success: false,
                    fail: false,
                    invalid: false,
                },
            }
        },
        computed: {
            isActing() {
                return this.work.job_id === 1;
            },
            workIsValid() {
                return this.work.person_id && this.work.title_id && this.work.job_id;
            },
        },
        methods: {
            async handleSubmit() {
                if (this.workIsValid) {
                    try {
                        let response, work_id;
                        response = await fetch(`http://localhost:8081/api/works`, {
                            method: 'POST',
                            body: JSON.stringify(this.work),
                            headers: {'Content-type': 'application/json; charset=UTF-8'}
                        });
                        this.errors.success = await response.json();
                        this.character_name = this.character_name.trim();
                        if (!this.errors.success) {
                            this.errors.fail = true;
                        } else if (this.isActing && this.character_name) {
                            response = await fetch(`http://localhost:8081/api/works?order=id%20DESC`);
                            work_id = await response.json();
                            work_id = work_id[0].id;
                            response = await fetch(`http://localhost:8081/api/roles`, {
                                method: 'POST',
                                body: JSON.stringify({name: this.character_name, work_id: work_id}),
                                headers: {'Content-type': 'application/json; charset=UTF-8'},
                            });
                            this.errors.success = await response.json();
                            if (!this.errors.success) {
                                this.errors.fail = true
                            } else {
                                this.resetInput()
                            }
                        }
                    } catch (e) {
                        console.error(e);
                        this.errors.fail = true;
                    }
                } else {
                    this.errors.invalid = true;
                }
            },
            savePerson(person) {
                this.resetErrors();
                this.person = person;
                this.work.person_id = person.id;
            },
            saveTitle(title) {
                this.resetErrors();
                this.title = title;
                this.work.title_id = title.id;
            },
            saveJob(job) {
                this.resetErrors();
                this.job = job;
                this.work.job_id = job.id;
            },
            async losePerson(reset) {
                if (reset) {
                    this.resetErrors();
                }
                this.person = null;
                this.work.person_id = null;
                await this.$forceUpdate();
                document.getElementById('quick-select-people-input').focus();
            },
            async loseTitle(reset) {
                if (reset) {
                    this.resetErrors();
                }
                this.title = null;
                this.work.title_id = null;
                await this.$forceUpdate();
                document.getElementById('quick-select-entertainment-input').focus();
            },
            async loseJob(reset) {
                if (reset) {
                    this.resetErrors();
                }
                this.job = null;
                this.work.job_id = null;
                this.character_name = '';
                await this.$forceUpdate();
                document.getElementById('custom-select-jobs-button').focus();
            },
            resetErrors() {
                this.errors.fail = false;
                this.errors.success = false;
                this.errors.invalid = false;
            },
            resetInput() {
                this.loseJob(false);
                this.loseTitle(false);
                this.losePerson(false);
            },
        }
    }
</script>

<style scoped>
</style>